export declare type ActionCreator<Name extends string, T> = {
    readonly type: Name;
    new (payload: T): {
        [key in keyof T]: T[key];
    };
};
export declare type EmptyActionCreator<Name extends string> = {
    readonly type: Name;
    new (): {};
};
export declare type Props<P = any> = {
    _as: 'props';
    _p: P;
};
export declare type EmptyProps = {
    _as: 'empty';
};
export declare type TypeFromProps<P> = P extends Props<infer T> ? T : never;
export declare type SourceActionName<Source extends string, Name extends string> = `[${Source}] ${Name}`;
