import { Action } from "@ngxs/store";
function withoutProps() {
  return { _as: "empty" };
}
function withProps() {
  return { _as: "props", _p: void 0 };
}
function createAction(name, propType) {
  var _a, _b;
  if (propType === void 0 || propType._as === "empty") {
    return _a = class {
    }, _a.type = name, _a;
  } else {
    return _b = class {
      constructor(payload) {
        Object.entries(payload).forEach(([key, value]) => {
          Reflect.defineProperty(this, key, { value, writable: false });
        });
      }
    }, _b.type = name, _b;
  }
}
function createActionGroup(source, actions) {
  const result = Object.fromEntries(Object.entries(actions).map(([name, propsType]) => {
    return [
      toActionName(name),
      propsType._as === "empty" ? createAction(`[${source}] ${name}`) : createAction(`[${source}] ${name}`, propsType)
    ];
  }));
  return result;
}
function toActionName(eventName) {
  return eventName.trim().toLowerCase().split(" ").map(capitalize).join("");
}
function capitalize(text) {
  return text.charAt(0).toUpperCase() + text.substring(1);
}
function useActions(stateClass) {
  return function(actionCreator, handler, options) {
    const methodKey = Symbol();
    Reflect.defineProperty(stateClass, methodKey, {
      writable: false,
      value: handler
    });
    Action(actionCreator, options)(stateClass, methodKey, {});
  };
}
export { createAction, createActionGroup, useActions, withProps, withoutProps };
